//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <math.h>
#include <stdlib.h>
#include <fstream.h>
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
  N = 4096;

  XRange = 2*M_PI;

  A1 = 1;
  n1 = 3.5;
  f1 = 0;

  A2 = 0.6;
  n2 = 40;
  f2 = 0;

  A3 = 0.3;

  S = NULL;

  randomize();
}
//---------------------------------------------------------------------------

__fastcall TForm1::~TForm1()
{
  if(S) delete[] S;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  ReadParameters();

  GenerateSignal();

  DrawSignal();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  SaveSignal();
}
//---------------------------------------------------------------------------

void TForm1::ReadParameters()
{
  N = Edit1->Text.ToInt();
  if(N < 4)
    N = 4;

  dx = XRange/(N - 1);

  A1 = Edit2->Text.ToDouble();
  A2 = Edit5->Text.ToDouble();
  A3 = Edit8->Text.ToDouble();
  n1 = Edit3->Text.ToDouble();
  n2 = Edit6->Text.ToDouble();
  f1 = dx*Edit4->Text.ToInt();
  f2 = dx*Edit7->Text.ToInt();

  S = new double[N];
}
//---------------------------------------------------------------------------

void TForm1::GenerateSignal()
{
  for(int i = 0; i < N; i++)
    S[i] = Func(i*dx);

  Button2->Enabled = true;  
}
//---------------------------------------------------------------------------

double TForm1::Func(double x)
{
  if( (x < 0.25*XRange) || (x > 0.75*XRange) )
  {
    return A1*sin(n1*(x - f1)) +
           A3*(rand()/(double)RAND_MAX - 0.5);
  }
  else
  {
    return A1*sin(n1*(x - f1)) +
           A2*sin(n2*(x - f2)) +
           A3*(rand()/(double)RAND_MAX - 0.5);
  }
}
//---------------------------------------------------------------------------

void TForm1::DrawSignal()
{
  Series1->Clear();
  Series1->AddArray(S, N - 1);
}
//---------------------------------------------------------------------------

void TForm1::SaveSignal()
{
  if(SaveDialog1->Execute())
  {
    ofstream ofs(SaveDialog1->FileName.c_str());

    for(int i = 0; i < N; i++)
      ofs<<S[i]<<endl;

    ofs.close();
  }
}
//---------------------------------------------------------------------------
