//---------------------------------------------------------------------------
#include <vcl.h>
#include <fstream.h>
#include <math.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
  Depth = -1;
  layer_numb = -1;
  layer = new double*[1];
  layer[0] = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnDecompClick(TObject *Sender)
{
  if (CBLev->ItemIndex == -1) return;

  Depth = CBLev->ItemIndex + 1;

  Series2->Clear();
  Series3->Clear();

  int p = 1<<(n - 1);
  int q = 2;
  int r = 1;

  for (int lev = 1; lev <= Depth; lev++)
  {
    for (int k = 1; k <= p; k++)
      array[(2*k - 1)*r] -= 0.5*(array[(k - 1)*q] + array[k*q]);

    array[0]     += 0.5*array[r];
    array[N - 1] += 0.5*array[N - 1 - r];

    for (int k = 1; k < p; k++)
      array[k*q] += 0.25*(array[(2*k - 1)*r] + array[(2*k + 1)*r]);

    p >>= 1;
    r = q;
    q <<= 1;
  }

  CB1->Clear();
  for (int i = 1; i <= Depth + 1; i++)
    CB1->Items->Append(i);

  if (Depth == n)
    Edit1->Text = FloatToStrF(0.5*(array[0] + array[N - 1]), ffFixed, 5, 2);

  BtnThresh->Enabled = true;
  BtnReconstr->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnThreshClick(TObject *Sender)
{
  if (CB1->ItemIndex == -1) return;

  Threshold = EdtThresh->Text.ToDouble();

  for (int k = 0; k < layer_size; k++)
  {
    if (fabs(*layer[k]) <= Threshold)
      *layer[k] = 0;
  }

  if (Depth == n)
    Edit1->Text = FloatToStrF(0.5*(array[0] + array[N - 1]), ffFixed, 5, 2);

  Series3->Clear();
  for (int k = 0; k < layer_size; k++)
    Series3->AddY(*layer[k], "", clRed);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnReconstrClick(TObject *Sender)
{
  int p = 1<<(n - Depth);
  int r = 1<<(Depth - 1);
  int q = r<<1;

  for (int lev = Depth; lev > 0; lev--)
  {
    for (int k = 1; k < p; k++)
      array[k*q] -= 0.25*(array[(2*k - 1)*r] + array[(2*k + 1)*r]);

    array[0]     -= 0.5*array[r];
    array[N - 1] -= 0.5*array[N - 1 - r];

    for (int k = 1; k <= p; k++)
      array[(2*k - 1)*r] += 0.5*(array[(k - 1)*q] + array[k*q]);

    p <<= 1;
    q = r;
    r >>= 1;
  }

  CB1->Clear();

  Depth = -1;

  Series3->Clear();
  Series2->Clear();
  Series2->AddArray(array, N - 1);

  BtnThresh->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnLoadClick(TObject *Sender)
{
  if (OpenDialog1->Execute())
  {
    if (EdtN->Text != "")
    {
      Series3->Clear();

      N = EdtN->Text.ToInt();//!!!

      SetN();

      CBLev->Clear();
      for (int i = 1; i <= n; i++)
        CBLev->Items->Append(i);

      array = new double[N];

      LoadData();

      Series1->Clear();
      Series1->AddArray(array, N - 1);

      BtnDecomp->Enabled = true;
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetN()
{
  if (N <= 5)
  {
    N = 5;
    n = 2;
    EdtN->Text = "5";
  }
  else
  {
    int k1 = 4;
    n = 2;

    while (k1 + 1 < N)
    {
      k1 <<= 1;
      n++;
    }

    if (N <= k1) N = k1 + 1;

    EdtN->Text = IntToStr(N);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LoadData()
{
  ifstream file(OpenDialog1->FileName.c_str());

  for (int i = 0; i < N; i++)
    file>>array[i];

  file.close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CB1Change(TObject *Sender)
{
  Series3->Clear();

  layer_numb = CB1->ItemIndex + 1;

  delete[] layer;

  if (layer_numb <= Depth)
  {
    layer_size = 1<<(n - layer_numb);
    layer = new double*[layer_size];

    int t = 1<<(layer_numb - 1);

    for (int k = 0; k < layer_size; k++)
      layer[k] = &array[(2*k + 1)*t];
  }
  else
  {
    layer_size = (1<<(n - Depth)) + 1;
    layer = new double*[layer_size];

    int t = 1<<Depth;

    for (int k = 0; k < layer_size; k++)
      layer[k] = &array[k*t];
  }

  for (int k = 0; k < layer_size; k++)
    Series3->AddY(*layer[k], "", clRed);
}
//---------------------------------------------------------------------------

